#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "rebuild_connection4xi.py">
#<abstract4xi abstract = "providing function rebuild_connection4xi"/>
#<refer4xi reference = "reduction.py"/>
#<state4xi status = "[ACK4tagging] [ACK4OS2ALL] [NACK4moduletesting] [NACK4systemtesting] [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'rebuild_connection4xi' ] 
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import socket
import threading
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    pass         
except:
    pass
try:                 # rare ones
    pass         
except:
    pass 
try:                 # imported-as ones 
    pass          
except:
    pass            
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.reduction import rebuild_connection
except:
    print("rebuild_connection4xi.py: *** failed in from multiprocessing.reduction import rebuild_connection ***")
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
try:
    from connection4xi import Connection4Xi
except:
    print("** [NACK] in rebuil_connection4xi.py from connection4xi import Connection4Xi **")
        
from rebuild_handle4xi import rebuild_handle4xi

from print4xi import print4xi
from time4xi import time4xi
#"
#/>

 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "rebuild_connection4xi" usage = "
#   reduction.py
#       reduce_connection(conn):
#           return rebuild_connection, (ds, conn.readable, conn.writable)
#   reduce_connection4xi.py
#       reduce_connection4xi(conn):
#           return rebuild_connection4xi, (ds2xi, conn.readable, conn.writable)
#"> 
#<state4xi status = "[ACK4tagging] [ACK4OS2ALL] [NACK4moduletesting] [NACK4systemtesting] [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------
def rebuild_connection4xi(ds, readable, writable):
    '''
    returns Connection4Xi
    '''
    class2print = "rebuild_connection4xi"
    method2print = "srebuild_connection4xi"

    if sys.platform == 'win32':    
        
        # -----------------------------------------------------------------------------------------    
        # (Step 1/2) - Windows
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 1/2a) started" + "; rebuild-connection4xi-started: " + str(rebuild_connection4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        
        message2print = "{(Step 1/2b) passed" + "; ds-passed-to-rebuild-connection4xi: " + str(ds) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        
        message2print = "{(Step 1/2c) passed" + "; readable-passed-to-rebuild-connection4xi: " + str(readable) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        
        message2print = "{(Step 1/2d) passed" + "; writable-passed-to-rebuild-connection4xi: " + str(writable) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
                          
        message2print = "{(Step 1/2e) passing" + "; reduced-handle-passing-to-rebuild-handle4xi-by-rebuild-connection4xi: " + str(reduced_handle) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
            
        sock2xi = ds.detach()
        
        message2print = "{(Step 1/2f) set" + "; sock2xi-set-by-rebuild-connection4xi to: " + str(sock2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
                 
        # -----------------------------------------------------------------------------------------    
        # (Step 2/2) - Windows
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 2/2a) passing" + "; handle2xi-passing-to-Connection4Xi-by-rebuild-connection4xi: " + str(handle2xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
            
        message2print = "{(Step 2/2b) passing" + "; readable-passing-to-Connection4Xi-by-rebuild-connection4xi: " + str(readable) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        
        message2print = "{(Step 2/2c) passing" + "; writable-passing-to-Connection4Xi-by-rebuild-connection4xi: " + str(writable) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        
        message2print = "{(Step 2/2d) returning" + "; Connection4Xi-returning-by-rebuild-connection4xi: " + str(Connection4Xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                
        return Connection4Xi(sock2xi.detach(), readable, writable)
    else:
        # -----------------------------------------------------------------------------------------    
        # (Step 1/2) - Non Windows
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 1/2a) started" + "; rebuild-connection4xi-started: " + str(rebuild_connection4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        
        message2print = "{(Step 1/2b) passed" + "; df-passed-to-rebuild-connection4xi: " + str(df) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        
        message2print = "{(Step 1/2c) passed" + "; readable-passed-to-rebuild-connection4xi: " + str(readable) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        
        message2print = "{(Step 1/2d) passed" + "; writable-passed-to-rebuild-connection4xi: " + str(writable) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
                          
        message2print = "{(Step 1/2e) passing" + "; reduced-handle-passing-to-rebuild-handle4xi-by-rebuild-connection4xi: " + str(reduced_handle) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
            
        fd2xi = df.detach()
        
        message2print = "{(Step 1/2f) set" + "; fd2xi-set-by-rebuild-connection4xi to: " + str(fd2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
                 
        # -----------------------------------------------------------------------------------------    
        # (Step 2/2) - Non Windows
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 2/2a) passing" + "; handle2xi-passing-to-Connection4Xi-by-rebuild-connection4xi: " + str(handle2xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
            
        message2print = "{(Step 2/2b) passing" + "; readable-passing-to-Connection4Xi-by-rebuild-connection4xi: " + str(readable) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        
        message2print = "{(Step 2/2c) passing" + "; writable-passing-to-Connection4Xi-by-rebuild-connection4xi: " + str(writable) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        
        message2print = "{(Step 2/2d) returning" + "; Connection4Xi-returning-by-rebuild-connection4xi: " + str(Connection4Xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                
        return Connection4Xi(fd2xi, readable, writable)                    
    
#</function4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of rebuild_connection4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
